import es
import psyco
psyco.full()
import threading
import playerlib
import cPickle
import popuplib
import time
import os.path
import usermsg
import gamethread
import esamlib
import escinputlib
import random

###############################################################################################################################
##################################### Start of Options ########################################################################
###############################################################################################################################
##################################### Connection Options ######################################################################


connectiontype = 0              	# 1 = saving things in mySQL DB, e.g. for extern Hosting, ONLY Save, no READ, 0 = no extern hosting

myhost = "MYSQL Host"         		# if connectiontype = 1, the host of your MySQLDB

myuser = "MYSQL Username"     		# if connectiontype = 1, the user of your MySQLDB

mypw = "MYSQL Password"        		# if connectiontype = 1, the pw of your MySQLDB

mydb = "MYSQL Database"        		# if connectiontype = 1, the Database Name of your MySQL DB

serverid = 1                        # If you have more Server, write the Number of your Server here, e.g first Server Number 1

##################################### FTP Save Options ########################################################################

usedifferent = 0                    # 1 = Save Dataase on a different FTP Server, 0 = Save it on the Server

ftphost = "FTP HOST"              	# If different FTP Server, The Host from the FTP Server

ftpuser = "FTP USER"           		# If different FTP Server, The User from the FTP Server

ftppassword = "FTP PW"        		# If different FTP Server, The Password from the FTP Server

ftppath = "FTP Path"           	 	# If different FTP Server, The Path on the Server where it should save the Database, starting at your Login Folder, e.g: html/stamm, the Folder HAS TO exist

##################################### General Options #########################################################################


vip_type = "rounds"                	# "rounds" to count rounds, "kills" to count kills or "time" to count time played on the server, to get VIP

rounds_to_be_stammie = 2000         # How much rounds/kills/time must a player play/get, to get VIP, (time in hours)

infotime = 300                      # Every x seconds should come a Info message  ( 300 = every 5 min.)


##################################### Database Options ########################################################################

database_location = 'standard'      # If you not use the standard Database, e.g. an older Database, use the path, beginning after /cstrike like /addons/database/database.db, else use 'standard'

database_backup = 1                 # If 1, all round start, the Database make a Backup in the cstrike Folder


##################################### Force Options ###########################################################################


enable_filter = 1                   # 1 = If the Player have cl_downloadfilter not on all, he switch to spectator, 0 = off


##################################### Model Options ###########################################################################


enable_models = 1                   # 1 = enable VIP models, 0 = disable

admin_model = 1                     # Should Admins also get VIP Models 1 = Yes, 0 = no, these Admins are in secondadmins


##################################### Admin Options ###########################################################################


headadmins = ['STEAMID1', 'STEAMID2', 'STEAMID3'] # Steamids of the Head admins, for Admin menu etc.

secondadmins = ['STEAMID1', 'STEAMID2', 'STEAMID3']  # Here the steamids, which get NO Tag, or no Skin when they are VIP's

thirdadmins = ['STEAMID1', 'STEAMID2', 'STEAMID3'] # Steamids of admins, which not kicked when joining on a reserve_slot


##################################### Command Options #########################################################################

texttowrite = "!stamm"              # What to write to get actually played rounds/kills

autochat = 1                        # 0 = No VIP Message 1 = VIP's write in VIP Message, when they use the chat_prefix

chat_prefix = "+"                   # With which Prefix can the VIPS write in VIP Message

admin_menu = "!sadmin"              # Text to write in the Chat, for Admin Menu

viplist = "!viptop"                 # Text for Toplist of VIP's

viprank = "!viprank"                # Text for The VIP Rank


##################################### Holy Grenade Options ####################################################################


enable_holy_grenade = 1             # Should Vip's get a Holy Grenade? 1 = on, 0 = off

hear_holy_grenade = 1               # Should all hear the Holy grenadet sound? 1 = yes, 0 = no


##################################### VIP SLOT Options ########################################################################


enable_vip_slot = 0                 # Should a VIP get a Reserve Slot ? 1 = yes, 0 = no ( Own Reserveslot Function, not Mani's )

vip_slots = 0                  	    # if enable_vip_slot = 1, How much Reserveslots should there be ?

vip_kick_message = "You join on a VIP SLOT" # The Message, when someone join on a VIP SLOT

let_free = 0                        # Should there ever been a Slot free for VIP's, so kick a random person, when there is only 1 Slot free

vip_kick_message2 = 'You kicked to let a VIPSLOT free' # Message for the person who kicked then


##################################### Tag Options #############################################################################

stamm_tag_on_off = 1               # 1 = VIPS get a VIP Tag, 0 = They get no VIP TAG

stammtag = "--> *VIP*"             # Tag which a VIP get, please make a clearly Tag, e.g. not only x or something else like this

stammtag_pos = "x"                 # x = Tag before Name y = Tag behind Name


##################################### Display Options #########################################################################


see_text = 1                       # 1 = ALL see the rounds/kills/time, 0 = Only the Writer can see it

displaymode = 2                    # 1 = show rounds/kills/time in a window 2 = show rounds/kills/time in chat


##################################### Chat Options ############################################################################


vip_chatwelcome = 1                # should there come a message when a VIP join 1 = enable, 0 = disable

vip_chatgoodbye = 1                # should there come a message when a VIP leave 1 = enable, 0 = disable


##################################### Update Options ##########################################################################


updateaddon = 1                   # should there come a message, when there is a new version 1 = on, 0 = off


###############################################################################################################################
##################################### End of Options ##########################################################################
###############################################################################################################################





info = es.AddonInfo()
info.name = "VIP Addon"
info.version = "4.5E"
info.author = "Popoklopsi + Rain"
info.url = "http://www.tcaf-shootingrange.de/, http://www.team-wb.de/"
info.basename = "stamm_english"
info.description = "A Big VIP Addon whith Many Feature's inluded MYSQL"

stammies = {}

nademodel = None
dicter = {}

modellist = ['materials/models/player/vip/t_leet_vip/t_leet_normal.vtf', 'materials/models/player/vip/t_leet_vip/t_leet_glass_spec.vtf', 'materials/models/player/vip/t_leet_vip/t_leet_glass.vtf', 'materials/models/player/vip/t_leet_vip/t_leet_glass.vmt', 'materials/models/player/vip/t_leet_vip/t_leet_glass.vtf', 'materials/models/player/vip/t_leet_vip/t_leet.vtf', 'materials/models/player/vip/t_leet_vip/t_leet.vmt', 'models/player/vip/t_leet_vip/t_leet.vvd', 'models/player/vip/t_leet_vip/t_leet.sw.vtx', 'models/player/vip/t_leet_vip/t_leet.mdl', 'models/player/vip/t_leet_vip/t_leet.dx90.vtx', 'models/player/vip/t_leet_vip/t_leet.dx80.vtx', 'models/player/vip/t_leet_vip/t_leet.phy', 'materials/models/player/vip/t_guerilla_vip/t_guerilla_normal.vtf', 'materials/models/player/vip/t_guerilla_vip/t_guerilla.vtf', 'materials/models/player/vip/t_guerilla_vip/t_guerilla.vmt', 'models/player/vip/t_guerilla_vip/t_guerilla.vvd', 'models/player/vip/t_guerilla_vip/t_guerilla.sw.vtx', 'models/player/vip/t_guerilla_vip/t_guerilla.mdl', 'models/player/vip/t_guerilla_vip/t_guerilla.dx90.vtx', 'models/player/vip/t_guerilla_vip/t_guerilla.dx80.vtx', 'models/player/vip/t_guerilla_vip/t_guerilla.phy', 'materials/models/player/vip/ct_gsg9_vip/ct_gsg9_normal.vtf', 'materials/models/player/vip/ct_gsg9_vip/ct_gsg9.vtf', 'materials/models/player/vip/ct_gsg9_vip/ct_gsg9.vmt', 'models/player/vip/ct_gsg9_vip/ct_gsg9.vvd', 'models/player/vip/ct_gsg9_vip/ct_gsg9.sw.vtx', 'models/player/vip/ct_gsg9_vip/ct_gsg9.mdl', 'models/player/vip/ct_gsg9_vip/ct_gsg9.dx90.vtx', 'models/player/vip/ct_gsg9_vip/ct_gsg9.dx80.vtx', 'models/player/vip/ct_gsg9_vip/ct_gsg9.phy', 'materials/models/player/beagle/vipsealv1/ct_urban.vtf', 'materials/models/player/beagle/vipsealv1/ct_urban.vmt', 'models/player/beagle/vipsealv1/ct_urban.dx80.vtx', 'models/player/beagle/vipsealv1/ct_urban.dx90.vtx', 'models/player/beagle/vipsealv1/ct_urban.mdl', 'models/player/beagle/vipsealv1/ct_urban.phy', 'models/player/beagle/vipsealv1/ct_urban.sw.vtx', 'models/player/beagle/vipsealv1/ct_urban.vvd']
grenadelist = ['sound/stamm/throw1.wav', 'sound/stamm/explode1.wav', 'materials/holy_grenade/holy_grenade.vtf', 'models/holy_grenade/holy_grenade.mdl', 'models/holy_grenade/holy_grenade.xbox.vtx', 'materials/holy_grenade/holy_grenade.vmt', 'models/holy_grenade/holy_grenade.vvd', 'models/holy_grenade/holy_grenade.sw.vtx', 'models/holy_grenade/holy_grenade.phy', 'models/holy_grenade/holy_grenade.dx80.vtx', 'models/holy_grenade/holy_grenade.dx90.vtx']

def load():
	global stammies
	global servertable
	global file
	es.addons.registerSayFilter(vip_talk)
	if connectiontype == 1:
		global MySQLdb
		MySQLdb = None
		try:
			import MySQLdb
		except:
			es.msg('#multi', '#lightgreen ERROR, could #green not open MYSQL, #lightgreen Unload Script now!!!!')
			es.msg('#multi', '#lightgreen ERROR, could #green not open MYSQL, #lightgreen Unload Script now!!!!')
			es.msg('#multi', '#lightgreen ERROR, could #green not open MYSQL, #lightgreen Unload Script now!!!!')
			gamethread.delayed(5, es.unload,('stamm_english'))
	if usedifferent == 1:
		global ftplib
		ftplib = None
		try:
			import ftplib
		except:
			es.msg('#multi', '#lightgreen ERROR, could #green not open FTPLIB, #lightgreen Unload Script now!!!!')
			es.msg('#multi', '#lightgreen ERROR, could #green not open FTPLIB, #lightgreen Unload Script now!!!!')
			es.msg('#multi', '#lightgreen ERROR, could #green not open FTPLIB, #lightgreen Unload Script now!!!!')
			gamethread.delayed(5, es.unload,('stamm_german'))
	if vip_type == "time":
		gamethread.delayed(60, timer,())
	newpo = popuplib.create('admin_popup2')
	newpo.addline('Reset VIP List?')
	newpo.addline('------------------')
	newpo.addline('->1. Reset')
	newpo.addline('------------------')
	newpo.addline('->0. Close')
	newpo.menuselect = adminpopup2


	newp = popuplib.create('admin_popup')
	newp2 = popuplib.create('admin_popup3')
	newp2.addline('Stammies Vip Admin Menu')
	newp2.addline('----------------------------------------------------')
	newp2.addline("->1. Remove a Player from the VIP List")
	newp2.addline("->2. Reset VIP List (Kicks the Player with VIP Tag)")
	newp2.addline('----------------------------------------------------')
	newp2.addline('->8. Back')
	newp2.addline('->0. Close')
	newp.addline('Stammies Vip Admin Menu')
	newp.addline('----------------------------------------------------')
	if vip_type == "rounds":
		newp.addline('->1. Set Player Rounds')
	if vip_type == "kills":
		newp.addline('->1. Set Player Kills')
	if vip_type == "time":
		newp.addline('->1. Set Player Time ( In Minutes ) ')
	newp.addline('->2. Change Holy Grenade Status')
	newp.addline('->3. Change all hear Grenade Sound Status')
	newp.addline('->4. Change Vip Join Message Status')
	newp.addline('->5. Change Vip Leave Message Status')
	newp.addline('->6. Change Update Function Status')
	newp.addline('->7. Change VIP Models Status')
	if vip_type == "rounds":
		newp.addline('->8. Change Rounds to be a VIP')
	if vip_type == "kills":
		newp.addline('->8. Change Kills to be a VIP')
	if vip_type == "time":
		newp.addline('->8. Change Time to be a VIP')
	newp.addline('----------------------------------------------------')
	newp.addline("->9. Next Page")
	newp.addline('->0. Close')
	newp.submenu(9, newp2)
	newp2.submenu(8, newp)
	newp2.submenu(2, newpo)
	newp.menuselect = adminpopup
	newp2.menuselect = adminpopup3
	if database_location == 'standard':
		file = es.getAddonPath('stamm_english') + '/stammplayer.db'
	else:
		cstrikefolder = es.ServerVar('eventscripts_gamedir')
		file = '%s%s' % (cstrikefolder, database_location)
	if enable_holy_grenade == 1:
		es.doblock('corelib/noisy_on')
		gamethread.delayed(3, model,())
	if usedifferent == 1:
		readftp().start()
	else:
		if os.path.isfile(file):
			file_players = open(file)
			stammies = cPickle.load(file_players)
			file_players.close()
		else:
			save_dictionary()
	if enable_models == 1:
		download()
	es.msg("#multi", "#green Stammspieler by Popoklopsi #lightgreen loaded")
	es.set("%s" % info.basename,info.version)
	es.makepublic("%s" % info.basename)
	if connectiontype == 1:
		servertable = ("stamm_%i" % serverid)
		create().start()
	infotext()
	timer2()
	gamethread.delayed(60, timer5,())
	
def adminpopup(userid, choice, popupid):
	global enable_holy_grenade
	global hear_holy_grenade
	global vip_chatwelcome
	global vip_chatgoodbye
	global updateaddon
	global enable_models
	if choice == 1:
		if vip_type == "rounds":
			counter = 0
			Popup = popuplib.easymenu('adminmenu',None, playerchoose)
			Popup.settitle("Choose a Player")
			players = playerlib.getPlayerList('#all')
			for ply in players:
				counter += 1
				Popup.addoption(ply.userid, '%s' % es.getplayername(ply.userid))
			Popup.send(userid)
		if vip_type == "kills":
			counter = 0
			Popup = popuplib.easymenu('adminmenu',None, playerchoose1)
			Popup.settitle("Choose a Player")
			players = playerlib.getPlayerList('#all')
			for ply in players:
				counter += 1
				Popup.addoption(ply.userid, '%s' % es.getplayername(ply.userid))
			Popup.send(userid)
		if vip_type == "time":
			counter = 0
			Popup = popuplib.easymenu('adminmenu',None, playerchoose2)
			Popup.settitle("Choose a Player")
			players = playerlib.getPlayerList('#all')
			for ply in players:
				counter += 1
				Popup.addoption(ply.userid, '%s' % es.getplayername(ply.userid))
			Popup.send(userid)
	if choice == 2:
		if enable_holy_grenade == 1:
			enable_holy_grenade = 0
			es.msg('#multi', '#green Holy Grenade was #lightgreen disabled')
			popuplib.send('admin_popup', userid)
		elif enable_holy_grenade == 0:
			enable_holy_grenade = 1
			es.msg('#multi', '#green Holy Grenade was #lightgreen enabled')
			popuplib.send('admin_popup', userid)
	if choice == 3:
		if hear_holy_grenade == 1:
			if enable_holy_grenade == 1:
				hear_holy_grenade = 0
				es.msg('#multi', '#green All hear Holy Grenade Sounds #lightgreen Disabled')
				popuplib.send('admin_popup', userid)
		elif hear_holy_grenade == 0:
			if enable_holy_grenade == 1:
				hear_holy_grenade = 1
				es.msg('#multi', '#green All hear Holy Grenade Sounds #lightgreen Enabled')
				popuplib.send('admin_popup', userid)
	if choice == 4:
		if vip_chatwelcome == 1:
			vip_chatwelcome = 0
			es.msg('#multi', '#green Vip Join Text #lightgreen Disabled')
			popuplib.send('admin_popup', userid)
		elif vip_chatwelcome == 0:
			vip_chatwelcome = 1
			es.msg('#multi', '#green Vip Join Text #lightgreen Enabled')
			popuplib.send('admin_popup', userid)
	if choice == 5:
		if vip_chatgoodbye == 1:
			vip_chatgoodbye = 0
			es.msg('#multi', '#green Vip Leave Text #lightgreen Disabled')
			popuplib.send('admin_popup', userid)
		elif vip_chatgoodbye == 0:
			vip_chatgoodbye = 1
			es.msg('#multi', '#green Vip Leave Text #lightgreen Enabled')
			popuplib.send('admin_popup', userid)
	if choice == 6:
		if updateaddon == 1:
			updateaddon = 0
			es.msg('#multi', '#green Addon Update Function #lightgreen Disabled')
			popuplib.send('admin_popup', userid)
		elif updateaddon == 0:
			updateaddon = 1
			es.msg('#multi', '#green Addon Update Function #lightgreen Enabled')
			popuplib.send('admin_popup', userid)
	if choice == 7:
		if enable_models == 1:
			enable_models = 0
			es.msg('#multi', '#green VIP Models #lightgreen Disabled')
			popuplib.send('admin_popup', userid)
		elif enable_models == 0:
			enable_models = 1
			es.msg('#multi', '#green VIP Models #lightgreen Enabled')
			popuplib.send('admin_popup', userid)
	if choice == 8:
		if vip_type == "rounds":
			escinputlib.create('pointvalue3', 60, 'Rounds for VIP:', 'Rounds for VIP:', myfunc3)
			escinputlib.send('pointvalue3', userid)
		if vip_type == "kills":
			escinputlib.create('pointvalue4', 60, 'Kills for VIP:', 'Kills for VIP:', myfunc4)
			escinputlib.send('pointvalue4', userid)
		if vip_type == "time":
			escinputlib.create('pointvalue5', 60, 'Time for VIP:', 'Time for VIP:', myfunc5)
			escinputlib.send('pointvalue5', userid)
		
def adminpopup3(userid, choice, popupid):
	if choice == 1:
		Popup2 = popuplib.easymenu('adminmenu',None, playerchoose3)
		Popup2.settitle("Choose a Player")
		for x in stammies.keys():
			name = stammies[x]['name']
			if stammies[x]['VIP'] == 1:
				Popup2.addoption(x, name)
		Popup2.send(userid)
		
			
def adminpopup2(userid, choice, popupid):
	global servertable
	if choice == 1:
		for x in stammies.keys():
			stammies[x]["kills"] = 0
			stammies[x]["spawns"] = 0
			stammies[x]["time"] = 0
			stammies[x]["name"] = 0
			stammies[x]["VIP"] = 0
		es.msg('#multi', '#green The VIP List was resettet')
		if connectiontype == 1:
			servertable = ("stamm_%i" % serverid)
			delete().start()


def playerchoose(userid, choice, popupname):
	global thechoose
	thechoose = choice
	es.tell(userid, '#multi', '#green Press ESC and write the number of rounds you want to set')
	escinputlib.create('pointvalue', 60, 'Rounds to set:', 'Rounds to set:', myfunc)
	escinputlib.send('pointvalue', userid)

def playerchoose1(userid, choice, popupname):
	global thechoose
	thechoose = choice
	es.tell(userid, '#multi', '#green Press ESC and write the number of kills you want to set')
	escinputlib.create('pointvalue1', 60, 'Kills to set:', 'Kills to set:', myfunc1)
	escinputlib.send('pointvalue1', userid)

def playerchoose2(userid, choice, popupname):
	global thechoose
	thechoose = choice
	es.tell(userid, '#multi', '#green Press ESC and write the number of time you want to set (in minutes)')
	escinputlib.create('pointvalue2', 60, 'Time to set:', 'Time to set:', myfunc2)
	escinputlib.send('pointvalue2', userid)
	
def playerchoose3(userid, choice, popupname):
	global steamidtodelete
	steamidtodelete = choice
	stammies[steamidtodelete]["kills"] = 0
	stammies[steamidtodelete]["spawns"] = 0
	stammies[steamidtodelete]["time"] = 0
	stammies[steamidtodelete]["VIP"] = 0
	es.msg('#multi', '#lightgreen An Admin deleted STEAMID #green %s #lightgreen from the #green VIP LIST' % choice)
	if connectiontype == 1:
		delete2().start()

def myfunc(userid, argv):
	number1 = argv
	steamid15 = es.getplayersteamid(thechoose)
	thename = es.getplayername(thechoose)
	number2 = ' '.join(number1)
	number = int(number2)
	stammies[steamid15]["spawns"] = number
	es.msg('#multi', '#green The Number of Rounds from %s, set to %i' % (thename, number))
	popuplib.send('admin_popup', userid)

def myfunc1(userid, argv):
	number1 = argv
	steamid15 = es.getplayersteamid(thechoose)
	thename = es.getplayername(thechoose)
	number2 = ' '.join(number1)
	number = int(number2)
	stammies[steamid15]["kills"] = number
	es.msg('#multi', '#green The Number of Kills of %s, set to %i' % (thename, number))
	popuplib.send('admin_popup', userid)

def myfunc2(userid, argv):
	number1 = argv
	steamid15 = es.getplayersteamid(thechoose)
	thename = es.getplayername(thechoose)
	number2 = ' '.join(number1)
	number = int(number2)
	stammies[steamid15]["time"] = number
	es.msg('#multi', '#green The Number of Playtime of %s, set to %i' % (thename, number))
	popuplib.send('admin_popup', userid)

def myfunc3(userid, argv):
	global rounds_to_be_stammie
	number1 = argv
	number2 = ' '.join(number1)
	number = int(number2)
	rounds_to_be_stammie = number
	es.msg('#multi', '#green Now %i Rounds needed for VIP' % number)
	popuplib.send('admin_popup', userid)

def myfunc4(userid, argv):
	global rounds_to_be_stammie
	number1 = argv
	number2 = ' '.join(number1)
	number = int(number2)
	rounds_to_be_stammie = number
	es.msg('#multi', '#green Now %i Kills needed for VIP' % number)
	popuplib.send('admin_popup', userid)

def myfunc5(userid, argv):
	global rounds_to_be_stammie
	number1 = argv
	number2 = ' '.join(number1)
	number = int(number2)
	rounds_to_be_stammie = number
	es.msg('#multi', '#green Now %i Time needed for VIP' % number)
	popuplib.send('admin_popup', userid)


def round_start(ev):
	if usedifferent == 0:
		save_dictionary()
	if connectiontype == 1:
		insert().start()
		
def vip_talk(userid,text,teamonly):
	newtext = text.replace('"','')
	if es.getplayersteamid(userid) != 'BOT':
		if es.getplayersteamid(userid) != 'STEAM_ID_PENDING':
			if autochat == 1:
				if not newtext.startswith(chat_prefix): 
					return(userid, text, teamonly)
				else:
					if teamonly == 0:
						if stammies[es.getplayersteamid(userid)]["VIP"] == 1:
							player = userid
							playerp = playerlib.getPlayer(player)
							index = playerp.attributes['index']
							usermsg.saytext2('#all', index, '\x03[VIP Message] \x04%s\x01:\x03 %s'%(playerp.get('name'), newtext.strip(chat_prefix + ' ')))
							return(0,None,0)
					if teamonly == 1:
						if stammies[es.getplayersteamid(userid)]["VIP"] == 1:
							for x in es.getUseridList():
								if es.getplayerteam(x) == es.getplayerteam(userid):
									player = userid
									playerp = playerlib.getPlayer(player)
									index = playerp.attributes['index']
									usermsg.saytext2(x, index, '\x03[VIP Message] \x04%s\x01:\x03 %s'%(playerp.get('name'), newtext.strip(chat_prefix + ' ')))
									return(0,None,0) 
			if autochat == 0:
				return(userid, text, teamonly)

def unload():
	if usedifferent == 1:
		saveftp().start()
	else:
		save_dictionary()
	if enable_holy_grenade == 1:
		es.doblock('corelib/noisy_off')

def model():
	global nademodel
	if enable_holy_grenade == 1:
		nademodel = es.precachemodel("models/holy_grenade/holy_grenade.mdl")

def weapon_fire(ev):
	steamid9 = ev['es_steamid']
	if enable_holy_grenade == 1:
		if steamid9 != 'BOT':
			if steamid9 != 'STEAM_ID_PENDING':
				if ev["weapon"] == "hegrenade":
					if stammies[steamid9]["VIP"] == 1:
						if hear_holy_grenade == 0:
							es.cexec(ev["userid"], "play stamm/throw1.wav")
						if hear_holy_grenade == 1:
							es.cexec_all("play stamm/throw1.wav")
						gamethread.delayed(0.3, change,())

def hegrenade_detonate(ev):
	steamid10 = ev['es_steamid']
	if enable_holy_grenade == 1:
		if steamid10 != 'BOT':
			if steamid10 != 'STEAM_ID_PENDING':
				if stammies[steamid10]["VIP"] == 1:
					if hear_holy_grenade == 0:
						es.cexec(ev["userid"], "play stamm/explode1.wav")
					if hear_holy_grenade == 1:
						es.cexec_all("play stamm/explode1.wav")

def player_spawn(ev):
	steamid1 = ev["es_steamid"]
	if steamid1 != 'BOT':
		if steamid1 != 'STEAM_ID_PENDING':
			if stammies[steamid1]["VIP"] == 0:
				if stammtag in ev['es_username']:
					es.server.queuecmd("es kickid %s You are not a VIP and use the VIPtag" % ev['userid'])
	if vip_type == "rounds":
		if steamid1 != 'BOT':
			if steamid1 != 'STEAM_ID_PENDING':
				stammies[steamid1]["spawns"] = stammies[steamid1]["spawns"] + 1
				if stammies[steamid1]["spawns"] >= rounds_to_be_stammie:
					if stammies[steamid1]["VIP"] == 0:
						stammies[steamid1]["VIP"] = 1
						es.msg("#multi", "#lightgreen [ #green Stamm #lightgreen ] #green %s is now a VIP" % str(ev["es_username"]))
						es.tell(ev["userid"], "#multi", "#lightgreen [ #green Stamm #lightgreen ] #green rejoin to use all VIP stuff's")
						if connectiontype == 1:
							insert2().start()
	if steamid1 != 'BOT':
		if steamid1 != 'STEAM_ID_PENDING':
			if stammies[steamid1]["VIP"] == 1:
				if enable_models == 1:
					if int(ev["es_userteam"]) != 0:
						if steamid1 in secondadmins:
							if admin_model == 1:
								randzahl = random.randint(1, 2)
								modeldict = {1: {2: {"modelpfad": "player/vip/t_leet_vip/t_leet.mdl"}, 3: {"modelpfad": "player/beagle/vipsealv1/ct_urban.mdl"}}, 2: {2: {"modelpfad": "player/vip/t_guerilla_vip/t_guerilla.mdl"}, 3: {"modelpfad": "player/vip/ct_gsg9_vip/ct_gsg9.mdl"}}}
								skin = modeldict[randzahl][int(ev["es_userteam"])]["modelpfad"]
								player = playerlib.getPlayer(ev["userid"])
								player.set("model", skin)
						else:
							randzahl = random.randint(1, 2)
							modeldict = {1: {2: {"modelpfad": "player/vip/t_leet_vip/t_leet.mdl"}, 3: {"modelpfad": "player/beagle/vipsealv1/ct_urban.mdl"}}, 2: {2: {"modelpfad": "player/vip/t_guerilla_vip/t_guerilla.mdl"}, 3: {"modelpfad": "player/vip/ct_gsg9_vip/ct_gsg9.mdl"}}}
							skin = modeldict[randzahl][int(ev["es_userteam"])]["modelpfad"]
							player = playerlib.getPlayer(ev["userid"])
							player.set("model", skin)

def es_player_validated(ev):
	steamid2 = ev["networkid"]
	if steamid2 != 'BOT':
		if steamid2 != 'STEAM_ID_PENDING':
			if not stammies.has_key(steamid2):
				stammies[steamid2] = {}
				stammies[steamid2]["spawns"] = 0
				stammies[steamid2]["kills"] = 0
				stammies[steamid2]["time"] = 0
				stammies[steamid2]["name"] = ev['name']
				stammies[steamid2]["VIP"] = 0
			else:
				if vip_type == "rounds":
					stammies[steamid2]["spawns"] = stammies[steamid2]["spawns"] - 1
					if stammies[steamid2]["spawns"] >= rounds_to_be_stammie:
						stammies[steamid2]["VIP"] = 1
					else:
						stammies[steamid2]["VIP"] = 0
				if vip_type == "time":
					if stammies[steamid2]["time"] / 60 >= rounds_to_be_stammie:
						stammies[steamid2]["VIP"] = 1
					else:
						stammies[steamid2]["VIP"] = 0
				if vip_type == "kills":
					if stammies[steamid2]["kills"] >= rounds_to_be_stammie:
						stammies[steamid2]["VIP"] = 1
					else:
						stammies[steamid2]["VIP"] = 0
				stammies[steamid2]["name"] = ev['name']

def player_death(ev):
	if vip_type == "kills":
		steamid6 = ev["es_attackersteamid"]
		if steamid6 != 'BOT':
			if steamid6 != 'STEAM_ID_PENDING':
				if steamid6 != ev['es_steamid']:
					stammies[steamid6]["kills"] = stammies[steamid6]["kills"] + 1
					if stammies[steamid6]["kills"] >= rounds_to_be_stammie:
						if stammies[steamid6]["VIP"] == 0:
							stammies[steamid6]["VIP"] = 1
							es.msg("#multi", "#lightgreen [ #green Stamm #lightgreen ] #green %s is now a VIP" % str(ev["es_attackername"]))
							es.tell(ev["attacker"], "#multi", "#lightgreen [ #green Stamm #lightgreen ] #green rejoin to use all VIP stuff's")
							if connectiontype == 1:
								insert2().start()

def download():
	for model in modellist:
		es.stringtable("downloadables", model)
	if enable_holy_grenade == 1:
		for x in grenadelist:
			es.stringtable("downloadables", x)
			
class saveftp(threading.Thread):
	def run(self):
		file_players = open('stammplayer.db', 'wb')
		cPickle.dump(stammies, file_players)
		file_players.close()
		conn = ftplib.FTP(ftphost)
		conn.login(ftpuser, ftppassword)
		conn.cwd(ftppath)
		conn.storbinary("STOR stammplayer.db", open('stammplayer.db', 'rb'), 1024)
		conn.close()
		
saveftp2 = saveftp()
		
class readftp(threading.Thread):
	def run(self):
		global stammies
		conn = ftplib.FTP(ftphost)
		conn.login(ftpuser,ftppassword)
		conn.cwd(ftppath)
		if 'stammplayer.db' in conn.nlst():
			conn.retrbinary('RETR stammplayer.db', open('stammplayer.db', 'wb').write)
			conn.close()
			file_players = open('stammplayer.db')
			stammies = cPickle.load(file_players)
			file_players.close()
		else:
			conn.close()
			saveftp().start()

def player_say(ev):
	global dicter
	userid1 = ev["userid"]
	steamid3 = ev["es_steamid"]
	theteam = ev["es_username"]
	if ev['text'] == admin_menu:
		if steamid3 in headadmins:
			popuplib.send('admin_popup', userid1)
	if ev["text"] == texttowrite:
		if displaymode == 2:
			if vip_type == "kills":
				if see_text == 0:
					if stammies[steamid3]["VIP"] == 0:
						es.tell(userid1, '#multi', "#green You have #lightgreen %i #green kills, you need #lightgreen %i #green to be a vip" % ( stammies[steamid3]["kills"],rounds_to_be_stammie))
					if stammies[steamid3]["VIP"] == 1:
						es.tell(userid1, '#multi', "#green You have #lightgreen %i #green kills, you are already a VIP" % stammies[steamid3]["kills"])
				if see_text == 1:
					if stammies[steamid3]["VIP"] == 0:
						es.msg('#multi', "#green %s has #lightgreen %i #green kills, he needs #lightgreen %i #green to be a vip" % (theteam, stammies[steamid3]["kills"],rounds_to_be_stammie))
					if stammies[steamid3]["VIP"] == 1:
						es.msg('#multi', "#green %s has #lightgreen %i #green kills, he's already a VIP" % (theteam, stammies[steamid3]["kills"]))
			if vip_type == "rounds":
				if see_text == 0:
					if stammies[steamid3]["VIP"] == 0:
						es.tell(userid1, '#multi', "#green You played #lightgreen %i #green rounds, you need #lightgreen %i #green to be a vip" % (stammies[steamid3]["spawns"], rounds_to_be_stammie))
					if stammies[steamid3]["VIP"] == 1:
						es.tell(userid1, '#multi', "#green You played #lightgreen %i #green rounds, you are already a VIP" % stammies[steamid3]["spawns"])
				if see_text == 1:
					if stammies[steamid3]["VIP"] == 0:
						es.msg('#multi', "#green %s played #lightgreen %i #green rounds, he needs #lightgreen %i #green to be a vip" % (theteam, stammies[steamid3]["spawns"], rounds_to_be_stammie))
					if stammies[steamid3]["VIP"] == 1:
						es.msg('#multi', "#green %s played #lightgreen %i #green rounds, he's already a VIP" % (theteam, stammies[steamid3]["spawns"]))
			if vip_type == "time":
				timenow3 = int(stammies[steamid3]["time"])
				timenow = timenow3 / 60
				timenow2 = timenow3 - (timenow * 60)
				if see_text == 0:
					if stammies[steamid3]["VIP"] == 0:
						es.tell(userid1, '#multi', "#green You played #lightgreen %i #green hours and #lightgreen %i #green minutes, you need #lightgreen %i houres #green to be a vip" % (timenow, timenow2, rounds_to_be_stammie))
					if stammies[steamid3]["VIP"] == 1:
						es.tell(userid1, '#multi', "#green You played #lightgreen %i #green hours and #lightgreen %i #green minutes, you are already a VIP" % (timenow, timenow2))
				if see_text == 1:
					if stammies[steamid3]["VIP"] == 0:
						es.msg('#multi', "#green %s played #lightgreen %i #green hours and #lightgreen %i #green minutes, he needs #lightgreen %i houres #green to be a vip" % (theteam, timenow, timenow2, rounds_to_be_stammie))
					if stammies[steamid3]["VIP"] == 1:
						es.msg('#multi', "#green %s played #lightgreen %i #green hours and #lightgreen %i #green minutes, he's already a VIP" % (theteam, timenow, timenow2))						
		if displaymode == 1:
			if vip_type == "kills":
				if see_text == 0:
					if stammies[steamid3]["VIP"] == 0:
						es.menu(5, userid1, "You have %i kills, you need %i, to be a VIP." % (stammies[steamid3]["kills"], rounds_to_be_stammie))
					if stammies[steamid3]["VIP"] == 1:
						es.menu(5, userid1, "You have %i kills, you are already a VIP." % (stammies[steamid3]["kills"]))
				if see_text == 1:
					if stammies[steamid3]["VIP"] == 0:
						for userid in es.getUseridList():
							es.menu(5, userid, "%s has %i kills, he needs %i, to be a VIP." % (theteam, stammies[steamid3]["kills"], rounds_to_be_stammie))
					if stammies[steamid3]["VIP"] == 1:
						for userid in es.getUseridList():
							es.menu(5, userid, "%s has %i kills, he's already a VIP." % (theteam, stammies[steamid3]["kills"]))
			if vip_type == "rounds":
				if see_text == 0:
					if stammies[steamid3]["VIP"] == 0:
						es.menu(5, userid1, "You played %i rounds, you need %i, to be a VIP." % (stammies[steamid3]["spawns"], rounds_to_be_stammie))
					if stammies[steamid3]["VIP"] == 1:
						es.menu(5, userid1, "You played %i rounds, you are already a VIP." % (stammies[steamid3]["spawns"]))
				if see_text == 1:
					if stammies[steamid3]["VIP"] == 0:
						for userid in es.getUseridList():
							es.menu(5, userid, "%s played %i rounds, he needs %i, to be a VIP." % (theteam, stammies[steamid3]["spawns"], rounds_to_be_stammie))
					if stammies[steamid3]["VIP"] == 1:
						for userid in es.getUseridList():
							es.menu(5, userid, "%s played %i rounds, he's already a VIP." % (theteam, stammies[steamid3]["spawns"]))
			if vip_type == "time":
				timenow3 = int(stammies[steamid3]["time"])
				timenow = timenow3 / 60
				timenow2 = timenow3 - (timenow * 60)
				if see_text == 0:
					if stammies[steamid3]["VIP"] == 0:
						es.menu(5, userid1, "You played %i hours and %i minutes, you need %i hours to be a vip" % (timenow, timenow2, rounds_to_be_stammie))
					if stammies[steamid3]["VIP"] == 1:
						es.menu(5, userid1, "You played %i hours and %i minutes, you are already a VIP" % (timenow, timenow2))
				if see_text == 1:
					if stammies[steamid3]["VIP"] == 0:
						for userid in es.getUseridList():
							es.menu(5, userid, "%s played %i hours and %i minutes, he needs %i hours to be a vip" % (theteam, timenow, timenow2, rounds_to_be_stammie))
					if stammies[steamid3]["VIP"] == 1:
						for userid in es.getUseridList():
							es.menu(5, userid, "%s played %i hours and %i minutes, he's already a VIP" % (theteam, timenow, timenow2))
	if ev["text"] == "!sinfo":
		infopopup = popuplib.create('info')
		infopopup.addline('Stamm by Popoklopsi and Rain')
		infopopup.addline('Visit http://www.tcaf-shootingrange.de')
		infopopup.addline('Official Stammtag = %s' % stammtag)
		infopopup.addline('--------------------------------------------------------------------------------')
		infopopup.addline('VIP Features:')
		infopopup.addline(' ')
		if enable_holy_grenade == 1:
			infopopup.addline("VIP's get a Holy Grenade")
		if enable_models == 1:
			infopopup.addline("VIP's get a VIP Skin")
		if enable_vip_slot == 1:
			infopopup.addline("VIP's get a VIP SLOT")
		infopopup.addline("VIP's get a VIP Tag")
		infopopup.addline(" ")
		infopopup.addline('VIP Addon Info:')
		infopopup.addline(' ')
		infopopup.addline('%s for VIPTOP10 List' % viplist)
		infopopup.addline('%s for your VIP rank' % viprank)
		infopopup.addline(' ')
		infopopup.addline('Official Pages:')
		infopopup.addline(' ')
		infopopup.addline('addons.eventscripts.com/addons/view/stamm')
		infopopup.addline('www.team-wb.de')
		infopopup.addline('------------------------------------------------------------------------------')
		infopopup.addline('->0. Close')
		infopopup.send(ev['userid'])
	if ev["text"] == viplist:
		popuplib.send('viptop', ev['userid'])
	if ev["text"] == viprank:
		if vip_type == 'kills':
				if stammies[steamid3]['VIP'] == 1:
					place = dicter[steamid3]
					es.tell(ev['userid'], '#multi', '#green %i. #lightgreen Place with #green %i #lightgreen Kills' % (place, stammies[steamid3]['kills']))
				else:
					es.tell(ev['userid'], '#multi', '#lightgreen You are #green NO #lightgreen VIP')
		if vip_type == 'rounds':
				if stammies[steamid3]['VIP'] == 1:
					place = dicter[steamid3]
					es.tell(ev['userid'], '#multi', '#green %i. #lightgreen Place with #green %i #lightgreen Rounds' % (place, stammies[steamid3]['spawns']))
				else:
					es.tell(ev['userid'], '#multi', '#lightgreen You are #green NO #lightgreen VIP')
		if vip_type == 'time':
				if stammies[y]['VIP'] == 1:
					timenow3 = int(stammies[steamid3]["time"])
					timenow = timenow3 / 60
					timenow2 = timenow3 - (timenow * 60)
					place = dicter[steamid3]
					es.tell(ev['userid'], '#multi', '#green %i. #lightgreen Place with #green %i Hours #lightgreen and #green %i #lightgreen Minutes' % (place, timenow, timenow2))
				else:
					es.tell(ev['userid'], '#multi', '#lightgreen You are #green NO #lightgreen VIP')

def chooseit(userid, choice, popupid):
	pass
	
def timer5():
	if usedifferent == 1:
		saveftp().start()
	else:
		save_dictionary()
	gamethread.delayed(360, timer5, ())
	
def es_map_start(ev):
	if usedifferent == 1:
		gamethread.delayed(60, saveftp2.start,())
	if enable_models == 1:
		download()
	if updateaddon == 1:
		gamethread.delayed(60, updatenow.start, ())
	if enable_holy_grenade == 1:
		gamethread.delayed(3, model,())

def change():
	global nadelist
	nadelist = es.createentitylist("hegrenade_projectile")
	for x in nadelist:
		es.setindexprop(x, "CBaseEntity.m_nModelIndex", nademodel)
		es.setindexprop(x, "CBaseEntity.m_clrRender", -1)
	nadelist = None

class nowupdate(threading.Thread):
	def run(self):
		if not int(es.ServerVar("sv_lan")):
			q = esamlib.getAddon("stamm_english")
			newest_version = str(q.currentversion)
			if '4.5' != newest_version:
				es.centermsg("Version %s is available for Stamm" % newest_version)
				es.msg("#multi", "#lightgreen [ #green Stamm #lightgreen ] #green Version %s is available for #lightgreen Stamm" % newest_version)
				playerpopup2 = popuplib.create('playerpopup2')
				playerpopup2.addline("Stamm Update info")
				playerpopup2.addline('-----------------------------')
				playerpopup2.addline("Version %s is available for Stamm" % newest_version)
				playerpopup2.addline(" ")
				playerpopup2.addline("Update at:")
				playerpopup2.addline(" ")
				playerpopup2.addline("http://addons.eventscripts.com/addons/view/stamm_english")
				playerpopup2.addline('-----------------------------')
				for x in es.getUseridList():
					popuplib.send('playerpopup2', x)
					gamethread.delayed(20, popuplib.unsendname, ("playerpopup2", x))
					
updatenow = nowupdate()
				
def es_player_variable(ev):
	if ev['variable'] == "cl_downloadfilter":
		if ev['status'] == "success":
			if ev['value'] != "all":
				es.changeteam(ev['userid'], '1')
				es.menu(10, ev['userid'], 'Write\n cl_downloadfilter all\n in your Console')

def player_activate(ev):
	steamid4 = ev["es_steamid"]
	userid2 = ev["userid"]
	namebefore = ev["es_username"]
	theteam = ev["es_username"]
	if steamid4 != 'BOT':
		if steamid4 != 'STEAM_ID_PENDING':
			if enable_filter == 1:
				es.queryclientvar(ev['userid'], 'cl_downloadfilter')
			if stammies[steamid4]["VIP"] == 1:
				if stamm_tag_on_off == 1:
					if steamid4 not in secondadmins:
						if stammtag_pos == 'x':
							if stammtag not in namebefore:
								es.cexec(userid2, "name %s %s" % (stammtag,namebefore))
						if stammtag_pos == 'y':
							if stammtag not in namebefore:
								es.cexec(userid2, "name %s %s" % (namebefore,stammtag))
			if enable_vip_slot == 1:
				max_players = int(es.getmaxplayercount())
				player = int(es.getplayercount())
				max_slots = max_players - player
				if vip_slots > max_slots:
					if stammies[steamid4]["VIP"] == 0:
						if steamid4 not in thirdadmins:
							es.server.queuecmd("es kickid %s %s" % (ev['userid'], vip_kick_message))
				if let_free == 1:
					if max_slots == 1:
						kickdic = 0
						counter = 0
						theusersnow = es.getUseridList()
						for user in theusersnow:
							kicksteamid = es.getplayersteamid(user)
							if stammies[kicksteamid]["VIP"] == 0:
								if kicksteamid not in thirdadmins:
									if counter == 0:
										es.server.queuecmd("es kickid %s %s" % (str(user), vip_kick_message2))
										counter = 1
						
			if displaymode == 2:
				if vip_type == "kills":
					if see_text == 0:
						if stammies[steamid4]["VIP"] == 0:
							es.tell(userid2, '#multi', "#green You have #lightgreen %i #green kills, you need #lightgreen %i #green to be a vip" % ( stammies[steamid4]["kills"],rounds_to_be_stammie))
						if stammies[steamid4]["VIP"] == 1:
							es.tell(userid2, '#multi', "#green You have #lightgreen %i #green kills, you are already a VIP" % stammies[steamid4]["kills"])
					if see_text == 1:
						if stammies[steamid4]["VIP"] == 0:
							es.msg('#multi', "#green %s has #lightgreen %i #green kills, he needs #lightgreen %i #green to be a vip" % (theteam, stammies[steamid4]["kills"],rounds_to_be_stammie))
						if stammies[steamid4]["VIP"] == 1:
							es.msg('#multi', "#green %s has #lightgreen %i #green kills, he's already a VIP" % (theteam, stammies[steamid4]["kills"]))
				if vip_type == "rounds":
					if see_text == 0:
						if stammies[steamid4]["VIP"] == 0:
							es.tell(userid2, '#multi', "#green You played #lightgreen %i #green rounds, you need #lightgreen %i #green to be a vip" % ( stammies[steamid4]["spawns"],rounds_to_be_stammie))
						if stammies[steamid4]["VIP"] == 1:
							es.tell(userid2, '#multi', "#green You played #lightgreen %i #green rounds, you are already a VIP" % stammies[steamid4]["spawns"])
					if see_text == 1:
						if stammies[steamid4]["VIP"] == 0:
							es.msg('#multi', "#green %s played #lightgreen %i #green rounds, he needs #lightgreen %i #green to be a vip" % (theteam, stammies[steamid4]["spawns"],rounds_to_be_stammie))
						if stammies[steamid4]["VIP"] == 1:
							es.msg('#multi', "#green %s played #lightgreen %i #green rounds, he's already a VIP" % (theteam, stammies[steamid4]["spawns"]))
				if vip_type == "time":
					timenow3 = int(stammies[steamid4]["time"])
					timenow = timenow3 / 60
					timenow2 = timenow3 - (timenow * 60)
					if see_text == 0:
						if stammies[steamid4]["VIP"] == 0:
							es.tell(userid2, '#multi', "#green You played #lightgreen %i #green hours and #lightgreen %i #green minutes, you need #lightgreen %i houres #green to be a vip" % (timenow, timenow2, rounds_to_be_stammie))
						if stammies[steamid4]["VIP"] == 1:
							es.tell(userid2, '#multi', "#green You played #lightgreen %i #green hours and #lightgreen %i #green minutes, you are already a VIP" % (timenow, timenow2))
					if see_text == 1:
						if stammies[steamid4]["VIP"] == 0:
							es.msg('#multi', "#green %s played #lightgreen %i #green hours and #lightgreen %i #green minutes, he needs #lightgreen %i houres #green to be a vip" % (theteam, timenow, timenow2, rounds_to_be_stammie))
						if stammies[steamid4]["VIP"] == 1:
							es.msg('#multi', "#green %s played #lightgreen %i #green hours and #lightgreen %i #green minutes, he's already a VIP" % (theteam, timenow, timenow2))						
			if displaymode == 1:
				if vip_type == "kills":
					if see_text == 0:
						if stammies[steamid4]["VIP"] == 0:
							es.menu(5, userid2, "You have %i kills, you need %i, to be a VIP." % (stammies[steamid4]["kills"], rounds_to_be_stammie))
						if stammies[steamid4]["VIP"] == 1:
							es.menu(5, userid2, "You have %i kills, you are already a VIP." % (stammies[steamid4]["kills"]))
					if see_text == 1:
						if stammies[steamid4]["VIP"] == 0:
							for userid in es.getUseridList():
								es.menu(5, userid, "%s has %i kills, he needs %i, to be a VIP." % (theteam, stammies[steamid4]["kills"], rounds_to_be_stammie))
						if stammies[steamid4]["VIP"] == 1:
							for userid in es.getUseridList():
								es.menu(5, userid, "%s has %i kills, he's already a VIP." % (theteam, stammies[steamid4]["kills"]))
				if vip_type == "rounds":
					if see_text == 0:
						if stammies[steamid4]["VIP"] == 0:
							es.menu(5, userid2, "You played %i rounds, you need %i, to be a VIP." % (stammies[steamid4]["spawns"], rounds_to_be_stammie))
						if stammies[steamid4]["VIP"] == 1:
							es.menu(5, userid2, "You played %i rounds, you are already a VIP." % (stammies[steamid4]["spawns"]))
					if see_text == 1:
						if stammies[steamid4]["VIP"] == 0:
							for userid in es.getUseridList():
								es.menu(5, userid, "%s played %i rounds, he needs %i, to be a VIP." % (theteam, stammies[steamid4]["spawns"], rounds_to_be_stammie))
						if stammies[steamid4]["VIP"] == 1:
							for userid in es.getUseridList():
								es.menu(5, userid, "%s played %i rounds, he's already a VIP." % (theteam, stammies[steamid4]["spawns"]))
				if vip_type == "time":
					timenow3 = int(stammies[steamid4]["time"])
					timenow = timenow3 / 60
					timenow2 = timenow3 - (timenow * 60)
					if see_text == 0:
						if stammies[steamid4]["VIP"] == 0:
							es.menu(5, userid2, "You played %i hours and %i minutes, you need %i hours to be a vip" % (timenow, timenow2, rounds_to_be_stammie))
						if stammies[steamid4]["VIP"] == 1:
							es.menu(5, userid2, "You played %i hours and %i minutes, you are already a VIP" % (timenow, timenow2))
					if see_text == 1:
						if stammies[steamid4]["VIP"] == 0:
							for userid in es.getUseridList():
								es.menu(5, userid, "%s played %i hours and %i minutes, he needs %i hours to be a vip" % (theteam, timenow, timenow2, rounds_to_be_stammie))
						if stammies[steamid4]["VIP"] == 1:
							for userid in es.getUseridList():
								es.menu(5, userid, "%s played %i hours and %i minutes, he's already a VIP" % (theteam, timenow, timenow2))
			if stammies[steamid4]["VIP"] == 1:
				if vip_chatwelcome == 1:
					es.msg('#multi', "#green The VIP #lightgreen %s #green joint the game, #lightgreen respect #green him" % str(namebefore))

def player_disconnect(ev):
	steamid5 = ev["networkid"]
	name1 = ev["name"]
	if steamid5 != 'BOT':
		if steamid5 != 'STEAM_ID_PENDING':
			if stammies[steamid5]["VIP"] == 1:
				if vip_chatgoodbye == 1:
					es.msg('#multi', "#green The VIP #lightgreen %s #green left the game" % str(name1))

def save_dictionary():
	if database_backup == 1:
		cstrikefolder2 = es.ServerVar('eventscripts_gamedir')
		cstrikefolder3 = '%s/stamm_backup.db' % cstrikefolder2
		file_players2 = open(cstrikefolder3, 'wb')
		cPickle.dump(stammies, file_players2)
		file_players2.close()
	file_players = open(file, 'wb')
	cPickle.dump(stammies, file_players)
	file_players.close()

def infotext():
	if vip_type == "rounds":
		es.msg('#multi', '#green [ Stamm ] #lightgreen  is activated, type #green %s #lightgreen to see your current #green Rounds' % texttowrite )
	if vip_type == "kills":
		es.msg('#multi', '#green [ Stamm ] #lightgreen  is activated, type #green %s #green to see your current #green Kills' % texttowrite )
	if vip_type == "time":
		es.msg('#multi', '#green [ Stamm ] #lightgreen  is activated, type #green %s #green to see your current #green Playtime' % texttowrite )
	es.msg('#multi', '#lightgreen Type #green !sinfo , #lightgreen to see Infos about Stamm #green ( VIP FEATURES )')
	gamethread.delayed(infotime, infotext, ())

class create(threading.Thread):
	def run(self):
		conn = MySQLdb.connect (host = myhost,
								user = myuser,
								passwd = mypw,
								db = mydb)
		cur = conn.cursor ()
		cur.execute("""CREATE TABLE IF NOT EXISTS %s (steamid VARCHAR( 20 ), VIP INTEGER( 1 ), rounds INTEGER( 60 ), kills INTEGER( 60 ), playtime INTEGER ( 60 ), time INTEGER( 60 ), name VARCHAR( 100 ), PRIMARY KEY (steamid)) ENGINE = MYISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci""" % servertable )
		cur.close
		conn.close

class insert(threading.Thread):
	def run(self):
		conn = MySQLdb.connect (host = myhost,
								user = myuser,
								passwd = mypw,
								db = mydb)
		cur = conn.cursor ()
		if vip_type == "rounds":
			for x in stammies.keys():
				try:
					cur.execute("""INSERT INTO %s (steamid, VIP, rounds, kills, playtime, time, name) VALUES ('%s', '%s', '%s', 0, 0, 0, '%s') ON DUPLICATE KEY UPDATE VIP='%s', rounds = '%s', name = '%s'""" % (servertable, x,stammies[x]["VIP"],stammies[x]["spawns"], stammies[x]["name"], stammies[x]["VIP"], stammies[x]["spawns"], stammies[x]["name"]))
				except:
					pass
		if vip_type == "kills":
			for x in stammies.keys():
				if "'" not in stammies[x]['name']:
					try:
						cur.execute("""INSERT INTO %s (steamid, VIP, rounds, kills, playtime, time, name) VALUES ('%s', '%s', 0, '%s', 0, 0, '%s') ON DUPLICATE KEY UPDATE VIP='%s', kills = '%s', name = '%s'""" % (servertable, x,stammies[x]["VIP"],stammies[x]["kills"], stammies[x]["name"], stammies[x]["VIP"], stammies[x]["kills"], stammies[x]["name"]))
					except:
						pass
		if vip_type == "time":
			for x in stammies.keys():
				timenow2 = int(stammies[x]["time"] / 60)
				try:
					cur.execute("""INSERT INTO %s (steamid, VIP, rounds, kills, playtime, time, name) VALUES ('%s', '%s', 0, 0, '%s', 0, '%s') ON DUPLICATE KEY UPDATE VIP='%s', playtime = '%s', name = '%s'""" % (servertable, x,stammies[x]["VIP"],timenow2, stammies[x]["name"], stammies[x]["VIP"], timenow2, stammies[x]["name"]))
				except:
					pass
		cur.close
		conn.close
		
class insert2(threading.Thread):
	def run(self):
		viptime = ("%i" % time.time())
		conn = MySQLdb.connect (host = myhost,
								user = myuser,
								passwd = mypw,
								db = mydb)
		cur = conn.cursor ()
		for x in stammies.keys():
			if "'" not in stammies[x]['name']:
				timenow3 = int(stammies[x]["time"] / 60)
				try:
					cur.execute("""INSERT INTO %s (steamid, VIP, rounds, kills, playtime, time, name) VALUES ('%s', '%s', '%s', '%s', '%s', '%s', '%s') ON DUPLICATE KEY UPDATE time = '%s', name = '%s'""" % (servertable, x,stammies[x]["VIP"],stammies[x]["spawns"], stammies[x]["kills"], timenow3, viptime, stammies[x]["name"], viptime, stammies[x]["name"]))
				except:
					pass
		cur.close
		conn.close
		
class delete(threading.Thread):
	def run(self):
		conn = MySQLdb.connect (host = myhost,
								user = myuser,
								passwd = mypw,
								db = mydb)
		cur = conn.cursor ()
		cur.execute("""DROP TABLE %s""" % servertable )
		cur.close
		conn.close
		
class delete2(threading.Thread):
	def run(self):
		conn = MySQLdb.connect (host = myhost,
								user = myuser,
								passwd = mypw,
								db = mydb)
		cur = conn.cursor ()
		try:
			cur.execute("""INSERT INTO %s (steamid, VIP, rounds, kills, playtime, time, name) VALUES ('%s', 0, 0, 0, 0, 0, 0) ON DUPLICATE KEY UPDATE VIP = 0, rounds = 0, kills = 0, playtime = 0, time = 0""" % (servertable, steamidtodelete))
		except:
			pass
		cur.close
		conn.close

def timer():
	for userid in es.getUseridList():
		steamid12 = es.getplayersteamid(userid)
		name9 = es.getplayername(userid)
		if steamid12 != 'BOT':
			if steamid12 != 'STEAM_ID_PENDING':
				stammies[steamid12]["time"] = stammies[steamid12]["time"] + 1
				if stammies[steamid12]["time"]  >= rounds_to_be_stammie * 60:
					if stammies[steamid12]["VIP"] == 0:
						stammies[steamid12]["VIP"] = 1
						es.msg("#multi", "#lightgreen [ #green Stamm #lightgreen ] #green %s is now a VIP" % str(name9))
						es.tell(userid, "#multi", "#lightgreen [ #green Stamm #lightgreen ] #green rejoin to use all VIP stuff's")
						if connectiontype == 1:
							insert2().start()
	gamethread.delayed(60, timer, ())
	
def timer2():
	global dicter
	counter5 = 0
	vipp = popuplib.create('viptop')
	vipp.addline('VIP TOP 10 Liste')
	vipp.addline('-----------------------------')
	liste = []
	for x in stammies.keys():
		if stammies[x]['VIP'] == 1:
			if vip_type == 'kills':
				liste.append(stammies[x]['kills'])
			if vip_type == 'rounds':
				liste.append(stammies[x]['spawns'])
			if vip_type == 'time':
				liste.append(stammies[x]['time'])
	liste.sort()
	liste.reverse()
	for x in liste:
		for y in stammies:
			if vip_type == 'kills':
				if stammies[y]['kills'] == x:
					if stammies[y]['VIP'] == 1:
						if counter5 < 10:
							counter5 += 1
							vipp.addline('->%i. Place %s with %i Kills' % (counter5, stammies[y]['name'], stammies[y]['kills']))
			if vip_type == 'rounds':
				if stammies[y]['spawns'] == x:
					if stammies[y]['VIP'] == 1:
						if counter5 < 10:
							counter5 += 1
							vipp.addline('->%i. Place %s with %i Rounds' % (counter5, stammies[y]['name'], stammies[y]['spawns']))
			if vip_type == 'time':
				if stammies[y]['time'] == x:
					if stammies[y]['VIP'] == 1:
						if counter5 < 10:
							timenow3 = int(stammies[y]["time"])
							timenow = timenow3 / 60
							timenow2 = timenow3 - (timenow * 60)
							counter5 += 1
							vipp.addline('->%i. Place %s with %i Hours and %i Minutes' % (counter5, stammies[y]['name'], timenow, timenow2))
	vipp.addline('-----------------------------')
	vipp.addline('->0. Close')
	dicter = {}
	counter8 = 0
	liste2 = []
	for x in stammies.keys():
		if stammies[x]['VIP'] == 1:
			if vip_type == 'kills':
				liste2.append(stammies[x]['kills'])
			if vip_type == 'rounds':
				liste2.append(stammies[x]['spawns'])
			if vip_type == 'time':
				liste2.append(stammies[x]['time'])
	liste2.sort()
	liste2.reverse()
	for x in liste2:
		for y in stammies:
			if vip_type == 'kills':
				if stammies[y]['kills'] == x:
					counter8 += 1
					dicter[y] = counter8
			if vip_type == 'rounds':
				if stammies[y]['spawns'] == x:
					counter8 += 1
					dicter[y] = counter8
			if vip_type == 'time':
				if stammies[y]['time'] == x:
					counter8 += 1
					dicter[y] = counter8
	gamethread.delayed(1800, timer2, ())